// Copyright (c) 2021 Giorgos Vougioukas
//
// The license can be found in the LICENSE file.

#include "phoebe/definitions.h"
#include "phoebe/about_wnd.h"
#include "phoebe/changelog_wnd.h"
#include "phoebe/license_wnd.h"
#include "phoebe/main_wnd.h"
#include "phoebe/preferences_wnd.h"
#include "phoebe/preferences.h"
#include "phoebe/super_editor_wnd.h"
#include "phoebe/super_editor.h"
#include "phoebe/cursor.h"
#include "phoebe/switch_wnd.h"

#include "WDL/lice/lice.h"

//#include "phoebe/phoebe_plugin.h"

static void free_str(const char *p) { free((void *)p); }

HINSTANCE g_inst = NULL;
UINT g_scrollmessage;
bool g_hasrequestedquit = false;

WDL_FastString g_argfile;
WDL_FastString g_modpath;
WDL_FastString g_setpath;
WDL_FastString g_inipath;
WDL_FastString g_text_ext(".txt .h .cpp");

PHO_Preferences *g_preferences = NULL;

PHO_MainWnd *g_mainwnd = NULL;
PHO_LicenseWnd *g_licwnd = NULL;
PHO_ChangelogWnd *g_changelogwnd = NULL;
PHO_PreferencesWnd *g_prefwnd = NULL;
PHO_AboutWnd *g_aboutwnd = NULL;
PHO_SuperEditorWnd *g_supereditorwnd = NULL;
PHO_SuperEditor *g_supereditor = NULL;
PHO_Cursor *g_cursor = NULL;
PHO_SwitchWnd *g_switchwnd = NULL;

HWND g_gotolinewnd = NULL;
HWND g_gotolineoffsetwnd = NULL;
HWND g_findwnd = NULL;
HWND g_replacewnd = NULL;

LICE_IBitmap *g_scrollbar = NULL;

WDL_PtrKeyedArray<const char *> g_pluginimport(free_str);
WDL_StringKeyedArray<void *> g_pluginexport;
